--- app_chanspy.c	2014-03-11 15:13:47.659132908 -0700
+++ app_chanspy.c.themrrobert	2014-03-11 15:14:52.467477885 -0700
@@ -517,6 +517,7 @@
 	int running = 0, res, x = 0;
 	char inp[24] = {0};
 	char *name;
+	int bridge_connected = 0;
 	struct ast_frame *f;
 	struct ast_silence_generator *silgen = NULL;
 	struct ast_autochan *spyee_bridge_autochan = NULL;
@@ -582,14 +583,17 @@
 		/* And this hook lets us inject audio into the channel that the spied on
 		   channel is currently bridged with.
 		*/
+		bridge_connected = 0;
 		ast_audiohook_init(&csth.bridge_whisper_audiohook, AST_AUDIOHOOK_TYPE_WHISPER, "Chanspy", 0);
 
 		if ((spyee_bridge_autochan = ast_autochan_setup(ast_bridged_channel(spyee_autochan->chan)))) {
-			ast_channel_lock(spyee_bridge_autochan->chan);
+			res = ast_channel_lock(spyee_bridge_autochan->chan);
 			if (start_spying(spyee_bridge_autochan, spyer_name, &csth.bridge_whisper_audiohook)) {
 				ast_log(LOG_WARNING, "Unable to attach barge audiohook on spyee %s. Barge mode disabled!\n", name);
+			} else {
+				bridge_connected = 1;
 			}
-			ast_channel_unlock(spyee_bridge_autochan->chan);
+			res = ast_channel_unlock(spyee_bridge_autochan->chan);
 		}
 	}
 
@@ -632,6 +636,21 @@
 		}
 
 		if (ast_test_flag(flags, OPTION_BARGE) && f->frametype == AST_FRAME_VOICE) {
+			if(bridge_connected == 0) {
+				ast_audiohook_init(&csth.bridge_whisper_audiohook, AST_AUDIOHOOK_TYPE_WHISPER, "Chanspy", 0);
+		                if ((spyee_bridge_autochan = ast_autochan_setup(ast_bridged_channel(spyee_autochan->chan)))) {
+		                        res = ast_channel_lock(spyee_bridge_autochan->chan);
+		                        if (start_spying(spyee_bridge_autochan, spyer_name, &csth.bridge_whisper_audiohook)) {
+		                                ast_log(LOG_WARNING, "Unable to attach barge audiohook on spyee %s. Barge mode disabled!\n", name);
+		                        } else {
+		                                bridge_connected = 1;
+		                        }
+                		        res = ast_channel_unlock(spyee_bridge_autochan->chan);
+        		        }
+	
+
+			}
+
 			ast_audiohook_lock(&csth.whisper_audiohook);
 			ast_audiohook_lock(&csth.bridge_whisper_audiohook);
 			ast_audiohook_write_frame(&csth.whisper_audiohook, AST_AUDIOHOOK_DIRECTION_WRITE, f);